function SecuenciasCP
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PROGRAMA DE SECUENCIAS CUADRIPOLARES (SecuenciasCP.m) %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all;clear;clc
%!!!!!!!!! PARMETROS DE ENTRADA !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Pax_t=0;
Pay_t=0;
z_t=0;
c_roll_along=0;
salida1='a';
salida2='a';
% Cargar archivo de coordenadas 
[arche,ruta]=uigetfile('*.txt','Elija el archivo de coordenadas');
convarche=strcat(ruta,arche);
coordenadas=dlmread(convarche,'');
% Fin Carga archivo de coordenadas
for cont_arr=1:100000 %+++++++++++++++Iteracin de repeticin
    sal_AGI=salida1;
    sal_inf=salida2;
% Eleccin del arreglo 
nlineas=[1,60];
roll_along=c_roll_along;
pce=0;
if cont_arr==1 && c_roll_along==0
 dimension=menu('ELIJA','Tendido 2D','Tendido 3D');
 if dimension==1    
  arreglo=menu('ELIJA','Dipolo-dipolo','Wenner','Wenner-Schlumberger');
  roll_along=menu('ELIJA','Con roll-along','Sin roll-along');
  if roll_along==1
     p0=('Cuntos electrodos desea desplazarse?');
     cuadro0='Roll-along';
     pe0=inputdlg(p0,cuadro0,nlineas);
     eroll=str2num(pe0{1});
  end
 else
  arreglo=menu('ELIJA','Arreglo en L con Dipolo-dipolo',...
  'Arreglo en L con Wenner','Arreglo en L con Wenner-Schlumberger',...
  'Ecuatorial','Arreglo de esquina',...
  'Arreglo ecuatorial-diagonal','Arreglo mnimo acoplamiento',...
  'Arreglo ecuatorial-dipolar',...
  'Introducir arreglo manualmete');    
 end
elseif cont_arr>1 && c_roll_along==1
    p0=('Cuntos electrodos desea desplazarse?');
    cuadro0='Roll-along';
    pe0=inputdlg(p0,cuadro0,nlineas);
    eroll=str2num(pe0{1});    
else
 dimension=menu('ELIJA','Tendido 2D','Tendido 3D');
 if dimension==1    
  arreglo=menu('ELIJA','Dipolo-dipolo','Wenner','Wenner-Schlumberger');
  roll_along=menu('ELIJA','Con roll-along','Sin roll-along');
  if roll_along==1
      p0=('Cuntos electrodos desea desplazarse?');
      cuadro0='Roll-along';
      pe0=inputdlg(p0,cuadro0,nlineas);
      eroll=str2num(pe0{1});
  end
 else
  arreglo=menu('ELIJA','Arreglo en L con Dipolo-dipolo',...
  'Arreglo en L con Wenner','Arreglo en L con Wenner-Schlumberger',...
  'Ecuatorial','Arreglo de esquina',...
  'Arreglo ecuatorial-diagonal','Arreglo mnimo acoplamiento',...
  'Arreglo ecuatorial-dipolar',...
  'Introducir arreglo manualmete');    
 end
end
% Fin eleccin deL arreglo
% Clculo de los cuadripolos de entrada 
if roll_along==1 && cont_arr==1
 p1={'Introduzca el nmero del primer electrodo del arreglo',...
 'Introduzca el nmero del primer electrodo del barrido',...
 'Introduzca el nmero del electrodo final',...
 'Introduzca el nmero de niveles a los que quiera llegar'};
 dep1={'1','1','24','6'};
 cuadro1='Parmetros de entrada';
 pe1=inputdlg(p1,cuadro1,nlineas,dep1);
 pe=str2num(pe1{1,1});ei=str2num(pe1{2,1});
 ef=str2num(pe1{3,1});n=str2num(pe1{4,1});
elseif roll_along~=1
 p1={'Introduzca el nmero del primer electrodo del arreglo',...
 'Introduzca el nmero del primer electrodo del barrido',...
 'Introduzca el nmero del electrodo final',...
 'Introduzca el nmero de niveles a los que quiera llegar'};
 dep1={'1','1','24','6'};
 cuadro1='Parmetros de entrada';
 pe1=inputdlg(p1,cuadro1,nlineas,dep1);
 pe=str2num(pe1{1,1});ei=str2num(pe1{2,1});
 ef=str2num(pe1{3,1});n=str2num(pe1{4,1});    
end
if arreglo==1 % Dipolo-dipolo
    cd1=[ei ei+1 ei+2 ei+3];cd2=[ei+1 ei+2 ei+3 ei+4];
    cdn=[ei ei+1 ei+3 ei+4];cdsn=[ei ei+2 ei+3 ei+5];
elseif arreglo==2 % Wenner
    cd1=[ei ei+3 ei+1 ei+2];cd2=[ei+1 ei+4 ei+2 ei+3];
    cdn=[ei ei+6 ei+2 ei+4];cdsn=[ei ei+3 ei+1 ei+2];
elseif arreglo==3 % Wenner-Schlumberger
    cd1=[ei ei+3 ei+1 ei+2];cd2=[ei+1 ei+4 ei+2 ei+3];
    cdn=[ei ei+5 ei+2 ei+3];cdsn=[ei ei+4 ei+1 ei+3];
elseif arreglo==4 % Ecuatorial
  pce=menu('Existen ms de 2 electrodos inoperantes seguidos?','si','no');
    if pce==1
       p3=('Introduzca el electrodo en el que continuan las mediciones');
       cuadro2='Tendido de 2 lneas paralelas';
       pe2=inputdlg(p3,cuadro2,nlineas);
       ce=str2num(pe2{1});
p3=menu('Los electrodos de corriente se desplazan de forma creciente?',...
        'si','no');
           if p3==1
               cd1=[ei ei+3 ce+1 ce+2];cd2=[ei+1 ei+4 ce+2 ce+3];
               cdn=[ei ei+5 ce+2 ce+3];cdsn=[ei ei+4 ce+1 ce+3];               
           else
               cd1=[ei ei+3 ef-1 ef-2];cd2=[ei+1 ei+4 ef-2 ef-3];
               cdn=[ei ei+5 ef-2 ef-3];cdsn=[ei ei+4 ef-1 ef-3];
           end
    else
       cd1=[ei ei+3 ef-1 ef-2];cd2=[ei+1 ei+4 ef-2 ef-3];
       cdn=[ei ei+5 ef-2 ef-3];cdsn=[ei ei+4 ef-1 ef-3];
    end
elseif arreglo==5 % Arreglo de Esquina
    cd1=[pe ef pe+1 ef-1];cd2=[pe ef pe+2 ef-2];
    cdn=[pe+1 ef-1 pe+2 ef-2];cdsn=cd1;
elseif arreglo==6 % Arreglo ecuatorial-diagonal
    p3=('Introduzca el electrodo final de la primera lnea');
    cuadro3='Lneas no continuas';
    pe2=inputdlg(p3,cuadro3,nlineas);
    efl1=str2num(pe2{1});    
    p5=menu('Elija','Ecuatorial-diagonal 1','Ecuatorial-diagonal 2');
    if p5==1
   cd1=[ef efl1+(efl1-pe)+1 ei efl1+(efl1-pe)-1];
   cd2=[cd1(1) cd1(2) cd1(3)+1 cd1(4)-1];
   cdn=[ef-1 cd1(2)+1 cd1(3) cd1(4)];cdsn=cd1;
    else
        par1=efl1-pe;
   cd1=[efl1+1 efl1+2*par1-1 ei ef];
   cd2=[cd1(1) cd1(2) ei+1 cd1(4)-1];
   cdn=[cd1(1)+1 cd1(2)-1 cd1(3) cd1(4)];cdsn=cd1;
    end
elseif arreglo==7 % Arreglo mnimo acoplamiento
    pce=menu('Existen ms de 2 electrodos inoperantes seguidos?',...
             'si','no');
    if pce==1
       p3=('Introduzca el electrodo en el que continuan las mediciones');
       cuadro2='Tendido de 2 lneas paralelas';
       pe2=inputdlg(p3,cuadro2,nlineas);
       ce=str2num(pe2{1});
p3=menu('Los electrodos de corriente se desplazan de forma creciente?',...
        'si','no');
       if p3==1
           cd1=[pe ce ei ei+1];cd2=[pe ce ei+1 ei+2];
           cdn=[pe+1 ce+1 cd2(3) cd2(4)];cdsn=cd1; 
       else
   cd1=[pe ef ei ei+1];cd2=[pe ef ei+1 ei+2];
   cdn=[pe+1 ef-1 cd2(3) cd2(4)];cdsn=cd1;
       end
    else
   cd1=[pe ef ei ei+1];cd2=[pe ef ei+1 ei+2];
   cdn=[pe+1 ef-1 cd2(3) cd2(4)];cdsn=cd1;
    end   
elseif arreglo==8 % Arreglo ecuatorial-dipolar
    pce=menu('Existen ms de 2 electrodos inoperantes seguidos?',...
             'si','no');
    if pce==1
       p3=('Introduzca el electrodo en el que continuan las mediciones');
       cuadro2='Tendido de 2 lneas paralelas';
       pe2=inputdlg(p3,cuadro2,nlineas);
       ce=str2num(pe2{1});
p3=menu('Los electrodos de corriente se desplazan de forma creciente?',...
        'si','no');
       if p3==1
           cd1=[pe ce ei ce+1];cd2=[pe ce ei+1 ce+2];
           cdn=[pe+1 ce+1 cd2(3) cd2(4)];cdsn=cd1; 
       else
   cd1=[pe ef ei ef-1];cd2=[pe ef ei+1 ef-2];
   cdn=[pe+1 ef-1 cd2(3) cd2(4)];cdsn=cd1;
       end
    else
   cd1=[pe ef ei ef-1];cd2=[pe ef ei+1 ef-2];
   cdn=[pe+1 ef-1 cd2(3) cd2(4)];cdsn=cd1;
    end       
elseif arreglo==9 % Introducir el arreglo manualmente
p2={'Introduzca el primer cuadripolo',...
'Introduzca el segundo cuadripolo (siguiendo la secuencia del nivel 1)'...
'Introduzca el primer cuadripolo del nivel 2',...
'Introduzca el primer cuadripolo del subnivel 2'};
dep2={'[15,35,4,46]','[15,35,5,45]','[16,34,4,46]','[15,35,4,46]'};
cuadro2='La introduccin de los cuadripolos es de la forma [A,B,M,N]';
nlineas=[1,length(cuadro2)+12];
pe2=inputdlg(p2,cuadro2,nlineas,dep2);
cd1=str2num(pe2{1,1});cd2=str2num(pe2{2,1});
cdn=str2num(pe2{3,1});cdsn=str2num(pe2{4,1});    
pce=menu('Existen ms de 2 electrodos inoperantes seguidos?','si','no');
    if pce==1
       p3=('Introduzca el electrodo en el que continuan las mediciones');
       cuadropem='Electrodos inoperantes';
       pe2=inputdlg(p3,cuadropem,nlineas);
       ce=str2num(pe2{1});
    end
end
if max(cd1)-min(cd1)>3 && arreglo~=6
   p4=('Introduzca el electrodo final de la primera lnea');
   cuadro3='Lneas no continuas';
   pe3=inputdlg(p4,cuadro3,nlineas);
   efl1=str2num(pe3{1});
elseif arreglo~=6
   efl1=ef;
end
% Fin Clculo de los cuadripolos de entrada
%!!!!!!!!! FIN PARMETROS DE ENTRADA

%!!!!!!!!! INICIO CLCULO DE VARIABLES !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ii=[0 0 0 0];
% :::::: Ordenacin de los valores del 1er cuadripolo de menor a mayor:
%        x1, x2, x3, x4 respectivamente
for i=1:4
    if max(cd1)==cd1(i)
       x(i)=max(cd1)-ei;x4=i;
    elseif min(cd1)==cd1(i)
       x(i)=min(cd1)-ei;x1=i;
    else
        ii(i)=cd1(i);
    end
end
for i=1:4
    if max(ii)==ii(i)
        x(i)=max(ii)-ei;x3=i;
    elseif ii(i)~=0
        x(i)=ii(i)-ei;x2=i;
    end
end   
% :::::: Variables
       % ssn---Variable que determina si existe un subnivel 
       % ft---Factor de truncamiento para un barrido con n=sn=1 
       %      (1=se trunca, 0=no se trunca)
       % efi---Electrodo del cuadripolo ms cercano a ef
       % l---Factor para un barrido cuyos electrodos se desplazan de forma 
       %     decreciente
       % aei---Factor para el lmite del barrido en el caso de que el
       %       electrodo inicial fuera distinto de uno
j=0;k=0;ssn=0;iii=0;
for i=1:4
    if cd1(i)==cd2(i) && cd1(i)==ef || cd2(i)==ef
        j=j+1;
    end
    if cd1(i)==cdsn(i)
        ssn=ssn+1;
    end
    if cd1(i)==cdn(i) && cdn(i)==cdsn(i)
       iii=iii+1;
    end
end
    if iii==4
       ft=1;
    else
       ft=0;
    end
for i=1:4
    if cd1(i)~=cd2(i)
       efi(i)=j;
    else
       efi(i)=0;
    end    
end
jj=0;jjjj=0;
for i=1:4
    l(i)=0;
    jjj=2;
    if cd1(i)>efl1
        jjjj=jjjj+1;
    end
    if cd1(x2)>efl1 && cd1(x2)~=cd2(x2) && cd2(i)<cd1(i)
        l(x2)=jjj;
    end
    if cd1(x3)>efl1 && cd1(x3)~=cd2(x3) && cd2(i)<cd1(i)
        l(x3)=jjj;
    end
    if cd1(x4)>efl1 && cd1(x4)~=cd2(x4) && cd2(i)<cd1(i)
        l(x4)=jjj;
    end
end
if pe==ei || arreglo==4 || arreglo==7 || arreglo==8
    fnc=0;
else
    fnc=ei-pe;
end
%!!!!!!!!! FIN CLCULO DE VARIABLES

%!!!!!!!!! INICIO DE LA CREACIN DE CUADRIPOLOS !!!!!!!!!!!!!!!!!!!!!!!!!!!
   % vvv---Nmero de cuadripolos totales
   % jj---Subniveles
   % lim---lmite del barrido
   % liml1---lmite del barrido de la primera lnea
   % A,B---electrodos de corriente
   % M,N---electrodos de potencial
   % c---vector coeficientes uno de nivel
   % d---vector coeficientes de subnivel
   % l---vector coeficiente dos de nivel (parmetro que garantiza el
   %     desplazamiento del barrido para un nivel y subnivel igual a 1)
   % x---vector inter-relacin de un cuadripolo en un barrido de "n" y "s" 
   %     valores
   % xx---vector inter-relacin de un cuadripolo en un barrido de "n" y "s" 
   %      valores en lneas no continuas   
   % k1,k2,k3,k4---Constantes para garantizar, si los hay, electrodos fijos
   % cn, cnn---Factor que controla el lmite para el arreglo de mnimo
   %           acoplamiento
   c=cdn-cd1;d=cdsn-cd1;
   vv=0;
   j=1;jj=0;
   k1=0;k2=0;k3=0;k4=0;liml1=99999;
    for i=1:10000          % Contador de niveles
        if i==n*j+1 && ssn~=4
            j=j+1;jj=jj+1;
        end
% """""""""" Arreglos de lneas no continuas """"""""""""""""""""""""""""""
        if max(cd1)-min(cd1)>3
            if cd1(x3)<=efl1 && cd1(x3)~=cd2(x3)
                if max(cd1)==ef
                   c_lim=-c(x3)*(i-1-jj);d_lim=-d(x3)*(j-1);
                else
                   c_lim=0;d_lim=0;
                end
lim=ef-x(x3)-c(x3)*(i-1-jj)-d(x3)*(j-1)-efi(x3)+c_lim+d_lim;
liml1=efl1-x(x3)-c(x3)*(i-1-jj)-d(x3)*(j-1)-fnc;
            elseif cd1(x2)<=efl1 && cd1(x2)~=cd2(x2)
                if max(cd1)==ef
                   c_lim=-c(x2)*(i-1-jj);d_lim=-d(x2)*(j-1);
                else
                   c_lim=0;d_lim=0;
                end                
lim=ef-x(x2)-c(x2)*(i-1-jj)-d(x2)*(j-1)-efi(x2)-c_lim-d_lim;
liml1=efl1-x(x2)-c(x2)*(i-1-jj)-d(x2)*(j-1)-fnc;
            elseif cd1(x1)<=efl1 && cd1(x1)~=cd2(x1)
                if max(cd1)==ef
                   c_lim=-c(x1)*(i-1-jj);d_lim=-d(x1)*(j-1);
                else
                   c_lim=0;d_lim=0;
                end                
lim=ef-x(x1)-c(x1)*(i-1-jj)-d(x1)*(j-1)-efi(x1)-c_lim-d_lim;
liml1=efl1-x(x1)-c(x1)*(i-1-jj)-d(x1)*(j-1)-fnc;
            end
        else
           lim=ef-x(x4)-c(x4)*(i-1-jj)-d(x4)*(j-1);
        end
        if jjjj>=2
            lim=liml1;
        end
        for k=ei:lim % Contador del barrido sobre el tendido
            if cd1(1)==cd2(1)
                k1=k-ei-l(1)*(k-ei);
            end
            if cd1(2)==cd2(2)
                k2=k-ei-l(2)*(k-ei);
            end
            if cd1(3)==cd2(3)
                k3=k-ei-l(3)*(k-ei);
            end
            if cd1(4)==cd2(4)
                k4=k-ei-l(4)*(k-ei);
            end
            if max(cd1)-min(cd1)>3
                if pce==1
                    if max(cd1)==ef
                        liml1s=ce+c_lim+d_lim-1;
                    else
                        liml1s=ce-1;
                    end                    
                else
                    liml1s=efl1+c_lim+d_lim;
                end
               if k<liml1+1 || k>liml1s
vv=vv+1;
A(vv)=k+x(1)+c(1)*(i-1-jj)+d(1)*(j-1)-(k1)-l(1)*(k-ei);
B(vv)=k+x(2)+c(2)*(i-1-jj)+d(2)*(j-1)-(k2)-l(2)*(k-ei);
M(vv)=k+x(3)+c(3)*(i-1-jj)+d(3)*(j-1)-(k3)-l(3)*(k-ei);
N(vv)=k+x(4)+c(4)*(i-1-jj)+d(4)*(j-1)-(k4)-l(4)*(k-ei);
               end
% """""""""" Arreglos de lneas continuas """""""""""""""""""""""""""""""""
            else
vv=vv+1;
A(vv)=k+x(1)+c(1)*(i-1-jj)+d(1)*(j-1)-(k1);
B(vv)=k+x(2)+c(2)*(i-1-jj)+d(2)*(j-1)-(k2);
M(vv)=k+x(3)+c(3)*(i-1-jj)+d(3)*(j-1)-(k3);
N(vv)=k+x(4)+c(4)*(i-1-jj)+d(4)*(j-1)-(k4);
            end
        end
      if ft==1||lim<ei||liml1<ei||A(vv)==B(vv)||B(vv)==M(vv)||...
         M(vv)==N(vv)||B(vv)==N(vv)
          break
      end
    end
vvv=0;
vvvvv=0;
if cont_arr>1
    vunos=numCP;
else
    vunos=0;
end
for i=1:vv
    if A(i)~=B(i)&&B(i)~=M(i)&&M(i)~=N(i)&&B(i)~=N(i)&&A(i)~=M(i)&&...
       A(i)~=N(i)
            vvv=vvv+1;
            vunos=vunos+1;
            A1(vvv)=A(i);
            B1(vvv)=B(i);
            M1(vvv)=M(i);
            N1(vvv)=N(i);
            unos(vvv)=vunos;
    end
end
% """""""""" Roll-along """""""""""""""""""""""""""""""""""""""""""""""""""
if roll_along==1
    if cont_arr>1
        A1=zeros(numel(c_A1));
        B1=zeros(numel(c_A1));
        M1=zeros(numel(c_A1));
        N1=zeros(numel(c_A1));
        A1=c_A1;
        B1=c_B1;
        M1=c_M1;
        N1=c_N1;
    end
    A4=A1;
    B4=B1;
    M4=M1;
    N4=N1;
    unos4=unos;
    cdf_r=[unos4' A4' B4' M4' N4'];
    vvv4=vvv;
    for i=1:vvv
            A2(i)=A1(i)+eroll;
            B2(i)=B1(i)+eroll;
            M2(i)=M1(i)+eroll;
            N2(i)=N1(i)+eroll;
            if A1(i)<=eroll*cont_arr && B1(i)<=eroll*cont_arr && M1(i)...
               <=eroll*cont_arr && N1(i)<=eroll*cont_arr
                assa=0;
            else
                vvvvv=vvvvv+1;
                A3(vvvvv)=A2(i);
                B3(vvvvv)=B2(i);
                M3(vvvvv)=M2(i);
                N3(vvvvv)=N2(i);
                unos1(vvvvv)=vvvvv;
            end
    end
    A1=A3;
    B1=B3;
    M1=M3;
    N1=N3;
    unos=unos1;
    vvv=vvvvv;    
    unosr=zeros(1,vvv);
    if cont_arr>1
        uu=numCP;
    else
        uu=unos4(vvv4);
    end    
    for i=1:vvv
        uu=uu+1;
        unosr(i)=uu;
    end    
end
cdf=[unos' A1' B1' M1' N1'];
% Arreglo L 
if dimension==2 && arreglo==1 || arreglo==2 || arreglo==3 %wwwwwwwwwwwwwwww
p11={'Introduzca el numero de electrodo de los vertices de cada esquina que se quiera calcular',...
     };
dep21={'[]'};
cuadro21='Separe con una coma un vertice de otro [V1,V2,...]';
nlineas11=[1,length(cuadro21)+20];
pe21=inputdlg(p11,cuadro21,nlineas11,dep21);
cd11=str2num(pe21{1,1});
dif=cd11-pe;    
p1cdf=[A1' B1' M1' N1'];
if numel(cd11)>1 %
p2cdf=[A1'+dif(1,1) B1'+dif(1,1) M1'+dif(1,1) N1'+dif(1,1)];
unos_1=unos;
vvv_1=vvv;
A1_1=A1;
B1_1=B1;
M1_1=M1;
N1_1=N1;
icont=0;
if arreglo==1
    cond=4;
else
    cond=2;
end
for i=1:numel(A1)
    if p2cdf(i,cond)>cd11(1,2)
        icont=icont+1;
        p3cdf(icont,1)=p2cdf(i,1);
        p3cdf(icont,2)=p2cdf(i,2);
        p3cdf(icont,3)=p2cdf(i,3);
        p3cdf(icont,4)=p2cdf(i,4);
    end
end
p4cdf=zeros(numel(p3cdf(:,1))*(numel(cd11)-1),4);
p5cdf=zeros(numel(p3cdf(:,1))*(numel(cd11)-1)-42,4);
icont1=0;
for i=1:numel(p4cdf(:,1))
    if i>numel(p3cdf(:,1)) && i<=numel(p3cdf(:,1))*2
        p4cdf(i,:)=p4cdf(i-numel(p3cdf(:,1)),:)+dif(1,1);
    elseif i>numel(p3cdf(:,1))*2 && p4cdf(i-numel(p3cdf(:,1)),1)+dif(1,1)<47
        p4cdf(i,:)=p4cdf(i-numel(p3cdf(:,1)),:)+dif(1,1);
    elseif i<=numel(p3cdf(:,1))
        p4cdf(i,:)=p3cdf(i,:);
    end
    if p4cdf(i,1)~=0
        icont1=icont1+1;
        p5cdf(icont1,:)=p4cdf(i,:);
    end
end
limaL=numel(A1)+numel(p5cdf(:,1));
iicont=0;
unos=zeros(1,limaL);
A1=zeros(1,limaL);
B1=zeros(1,limaL);
M1=zeros(1,limaL);
N1=zeros(1,limaL);
cdf=zeros(numel(A1,5));
for i=1:limaL
    iicont=iicont+1;
    unos(i)=iicont;
    if i<=numel(A1_1)
        A1(i)=A1_1(i);
        B1(i)=B1_1(i);
        M1(i)=M1_1(i);
        N1(i)=N1_1(i);
    else
        A1(i)=p5cdf((i-numel(A1_1)),1);
        B1(i)=p5cdf((i-numel(A1_1)),2);
        M1(i)=p5cdf((i-numel(A1_1)),3);
        N1(i)=p5cdf((i-numel(A1_1)),4);
    end
end
vvv=numel(A1);
cdf=[unos' A1' B1' M1' N1'];
end              %
end                                                       %wwwwwwwwwwwwwwww
%  Numero de cuadripolos totales 
if dimension==2
    if arreglo==1 || arreglo==2 || arreglo==3
        vvvv={num2str(unos(vvv));'cuadripolos'};
    else
        vvvv={num2str(vunos);'cuadripolos'};
    end
else
    vvvv={num2str(vunos);'cuadripolos'};
end
%!!!!!!!!! FIN DE LA CREACIN DE CUADRIPOLOS

%!!!!!!!!!! PROFUNDIDAD DE INVESTIGACIN !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cx=coordenadas(:,2);
cy=coordenadas(:,3);
cz=coordenadas(:,4);
if coordenadas(1,1)==1
    ne=0;
else
    ne=coordenadas(1,1)-1;
end
for i=1:vvv
% Clculo de la longitud total del cuadripolo 
    MAB=((cx(A1(i)-ne)-cx(B1(i)-ne))^2+(cy(A1(i)-ne)-cy(B1(i)-ne))^2)^0.5;
    MMN=((cx(M1(i)-ne)-cx(N1(i)-ne))^2+(cy(M1(i)-ne)-cy(N1(i)-ne))^2)^0.5;
    if dimension==2
       % ::::: Coordenadas del punto medio de A y B
       [Cxc,Cyc]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));
       % ::::: Coordenadas del punto medio de M y N
       [Pxc,Pyc]=XcYc(cx(M1(i)-ne),cy(M1(i)-ne),cx(N1(i)-ne),cy(N1(i)-ne));
       % :::::: Clculo de la longitud L
       Lp(i)=((Cxc-Pxc)^2+(Cyc-Pyc)^2)^0.5;
       if MMN<=0.1*Lp(i)+0.000001
           L(i)=Lp(i);
       else
   Lr(1)=MAB;
   Lr(2)=((cx(A1(i)-ne)-cx(M1(i)-ne))^2+(cy(A1(i)-ne)-cy(M1(i)-ne))^2)^0.5;
   Lr(3)=((cx(A1(i)-ne)-cx(N1(i)-ne))^2+(cy(A1(i)-ne)-cy(N1(i)-ne))^2)^0.5;
   Lr(4)=((cx(B1(i)-ne)-cx(M1(i)-ne))^2+(cy(B1(i)-ne)-cy(M1(i)-ne))^2)^0.5;
   Lr(5)=((cx(B1(i)-ne)-cx(N1(i)-ne))^2+(cy(B1(i)-ne)-cy(N1(i)-ne))^2)^0.5;
   Lr(6)=MMN;
   L(i)=max(Lr);
       end
    elseif arreglo==1 && dimension==1 % Dipolo-Dipolo
     MMN=((cx(M1(i)-ne)-cx(N1(i)-ne))^2+(cy(M1(i)-ne)-cy(N1(i)-ne))^2)^0.5;
     MBM=((cx(M1(i)-ne)-cx(B1(i)-ne))^2+(cy(M1(i)-ne)-cy(B1(i)-ne))^2)^0.5;
     L(i)=MAB/2+MBM+MMN/2;
     Lp(i)=L(i);
    elseif arreglo==2 && dimension==1 % Wenner
        L(i)=MAB;
        Lp(i)=L(i);
    elseif arreglo==3 && dimension==1 % Wenner-Schlumberger
        L(i)=MAB;
        Lp(i)=L(i);
    end
% Fin Clculo de la longitud total del cuadripolo                 
% Clculo de la profundidad de investigacin 
   if arreglo==1 % Dipolo-Dipolo
a2(i)=((cx(A1(i)-ne)-cx(B1(i)-ne))^2+(cy(A1(i)-ne)-cy(B1(i)-ne))^2)^0.5;
       z(i)=-0.25*L(i);
   elseif arreglo==2 % Wenner
a2(i)=((cx(A1(i)-ne)-cx(B1(i)-ne))^2+(cy(A1(i)-ne)-cy(B1(i)-ne))^2)^0.5;
       z(i)=-0.173*L(i);
   elseif arreglo==3 % Wenner-Schlumberger
a2(i)=((cx(A1(i)-ne)-cx(B1(i)-ne))^2+(cy(A1(i)-ne)-cy(B1(i)-ne))^2)^0.5;
       z(i)=-0.191*L(i);
   else
a1(i)=((cx(A1(i)-ne)-cx(B1(i)-ne))^2+(cy(A1(i)-ne)-cy(B1(i)-ne))^2)^0.5;
a(i)=((cx(M1(i)-ne)-cx(N1(i)-ne))^2+(cy(M1(i)-ne)-cy(N1(i)-ne))^2)^0.5;
if a1(i)>a(i)
    a2(i)=a1(i);
else
    a2(i)=a(i);
end
nt(i)=L(i)/a2(i);
u(i)=2*(nt(i)^2*(nt(i)+1)^2*(nt(i)+2)^2)/((nt(i)+1)^3*(nt(i)+2)^3-2*nt(i)^3*(nt(i)+2)^3+nt(i)^3*(nt(i)+1)^3);
z(i)=-a2(i)*(u(i)/4)^0.5;       
   end
% Fin Clculo de la profundidad de investigacin    
end
%!!!!!!!!!! FIN PROFUNDIDAD DE INVESTIGACIN

%!!!!!!!!!! COORDENADAS (x,y) DE LOS PUNTOS DE ATRIBUCIN !!!!!!!!!!!!!!!!!
for i=1:vvv
    if arreglo==1 && dimension==1 % <<<<<<<<<<<<<<<<----------Dipolo-Dipolo
 [Pax(i),Pay(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(N1(i)-ne),cy(N1(i)-ne));
    elseif arreglo==2 && dimension==1% <<<<<<<<<<<<<<<<<<<<<<<<<-----Wenner
 [Pax(i),Pay(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));
    elseif arreglo==3 && dimension==1% <<<<<<<<<<<<-----Wenner-Schlumberger
 [Pax(i),Pay(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));        
    else % <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<----------Arreglos 3D
     if arreglo==2 || arreglo==3
         if abs(cx(A1(i)-ne)-cx(B1(i)-ne))<0.000001 ||...
            abs(cy(A1(i)-ne)-cy(B1(i)-ne))<0.000001
 [Pax(i),Pay(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));             
         else
 [Cxm(i),Cym(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));
 [Pxm(i),Pym(i)]=XcYc(cx(M1(i)-ne),cy(M1(i)-ne),cx(N1(i)-ne),cy(N1(i)-ne));
 [Pax(i),Pay(i)]=XcYc(Cxm(i),Cym(i),Pxm(i),Pym(i));             
         end
     elseif arreglo==1
         if abs(cx(A1(i)-ne)-cx(N1(i)-ne))<0.000001 ||...
            abs(cy(A1(i)-ne)-cy(N1(i)-ne))<0.000001
 [Pax(i),Pay(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(N1(i)-ne),cy(N1(i)-ne));             
         else
 [Cxm(i),Cym(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));
 [Pxm(i),Pym(i)]=XcYc(cx(M1(i)-ne),cy(M1(i)-ne),cx(N1(i)-ne),cy(N1(i)-ne));
 [Pax(i),Pay(i)]=XcYc(Cxm(i),Cym(i),Pxm(i),Pym(i));             
         end
     else
 [Cxm(i),Cym(i)]=XcYc(cx(A1(i)-ne),cy(A1(i)-ne),cx(B1(i)-ne),cy(B1(i)-ne));
 [Pxm(i),Pym(i)]=XcYc(cx(M1(i)-ne),cy(M1(i)-ne),cx(N1(i)-ne),cy(N1(i)-ne));
 [Pax(i),Pay(i)]=XcYc(Cxm(i),Cym(i),Pxm(i),Pym(i));         
     end
    end
end
%''''''''''' Puntos de atribucin para el roll_along ''''''''''''''''''''''
if roll_along==1
    for i=1:vvv4
        cxA=cx(A4(i)-ne);cyA=cy(A4(i)-ne);
        cxB=cx(B4(i)-ne);cyB=cy(B4(i)-ne);
        cxM=cx(M4(i)-ne);cyM=cy(M4(i)-ne);
        cxN=cx(N4(i)-ne);cyN=cy(N4(i)-ne);        
[Paxr(i),Payr(i),zr(i),Lpr(i),Lr(i),a2r(i)]=SecCP_rolla(vvv4,cxA,cyA,...
                                cxB,cyB,cxM,cyM,cxN,cyN,dimension,arreglo);
    end
cdABMNxyz_r=[unos4',A4',B4',M4',N4',Paxr',Payr',zr',Lpr',Lr',a2r'];
end
%!!!!!!!!!! FIN COORDENADAS (x,y) DE LOS PUNTOS DE ATRIBUCIN

%!!!!!!!!! INICIO DE LA CREACIN DE ARCHIVOS ASCII !!!!!!!!!!!!!!!!!!!!!!!!
% Creacin archivo de salida para el ElectrePro 
if cont_arr==1
    [sal_AGI,ruta1]=uiputfile('*.txt',...
'Guarde el archivo de salida .txt para el ElectrePro','nombrame');
    if sal_AGI~=0
        salida1=strcat(ruta1,sal_AGI);
     lxyz_ep='#XYZ';
     lABMN='#ABMN';
     dlmwrite(salida1,lxyz_ep,'\t');
     dlmwrite(salida1,coordenadas,'-append','delimiter','\t');
     dlmwrite(salida1,lABMN,'-append','delimiter','\t');
     if roll_along==1
         dlmwrite(salida1,cdf_r,'-append','delimiter','\t');
         dlmwrite(salida1,cdf,'-append','delimiter','\t');
     else
         dlmwrite(salida1,cdf,'-append','delimiter','\t');
     end
    end
else
    dlmwrite(salida1,cdf,'-append','delimiter','\t');    
end
% Creacin archivo de informacin 
if roll_along==1
    unos=unosr;
end
cdABMNxyz=[unos',A1',B1',M1',N1',Pax',Pay',z',Lp',L',a2'];
if cont_arr==1 && roll_along~=1
    [sal_inf,ruta1]=uiputfile('*.txt',...
'Guarde el archivo de salida .txt de informacin','nombrame');
    if sal_inf~=0
        salida2=strcat(ruta1,sal_inf);
     lxyz={'Nmero del cuadripolo ------------------> columna 1';...
           'Electrodo A ----------------------------> columna 2';...
           'Electrodo B ----------------------------> columna 3';...
           'Electrodo M ----------------------------> columna 4';...
           'Electrodo N ----------------------------> columna 5';...
           'Coordenada x del punto de atribucin  --> columna 6';...
           'Coordenada y del punto de atribucin  --> columna 7';...
           'Profundidad efectiva de investigacin --> columna 8';...
           'Longitud L prima -----------------------> columna 9';...
           'Longitud L ----------------------------> columna 10';...
           'Abertura a ----------------------------> columna 11'};
lxyz1=[1,2,3,4,5,6,7,8,9,10,11];
dlmwrite(salida2,lxyz,'');
dlmwrite(salida2,'-','-append','delimiter','\t');
dlmwrite(salida2,lxyz1,'-append','delimiter','\t','precision','%8.0f');
dlmwrite(salida2,'-','-append','delimiter','\t');
dlmwrite(salida2,cdABMNxyz,'-append','delimiter','\t','precision','%8.2f');
    end
elseif roll_along~=1 && cont_arr>1
dlmwrite(salida2,cdABMNxyz,'-append','delimiter','\t','precision','%8.2f');
end
if roll_along==1 && cont_arr==1
    [sal_inf,ruta1]=uiputfile('*.txt',...
'Guarde el archivo de salida .txt de informacin','nombrame');
    if sal_inf~=0
        salida2=strcat(ruta1,sal_inf);    
     lxyz={'Nmero del cuadripolo ------------------> columna 1';...
           'Electrodo A ----------------------------> columna 2';...
           'Electrodo B ----------------------------> columna 3';...
           'Electrodo M ----------------------------> columna 4';...
           'Electrodo N ----------------------------> columna 5';...
           'Coordenada x del punto de atribucin  --> columna 6';...
           'Coordenada y del punto de atribucin  --> columna 7';...
           'Profundidad efectiva de investigacin --> columna 8';...
           'Longitud L prima -----------------------> columna 9';...
           'Longitud L ----------------------------> columna 10';...
           'Abertura a ----------------------------> columna 11'};
     lxyz1=[1,2,3,4,5,6,7,8,9,10,11];
     dlmwrite(salida2,lxyz,'');
     dlmwrite(salida2,'-','-append','delimiter','\t');
    dlmwrite(salida2,lxyz1,'-append','delimiter','\t','precision','%8.0f');
     dlmwrite(salida2,'-','-append','delimiter','\t');
     dlmwrite(salida2,cdABMNxyz_r,'-append','delimiter','\t',...
              'precision','%8.2f');
     dlmwrite(salida2,cdABMNxyz,'-append','delimiter','\t',...
              'precision','%8.2f');
    end
elseif roll_along==1 && cont_arr>1
dlmwrite(salida2,cdABMNxyz,'-append','delimiter','\t','precision','%8.2f');
end
if cont_arr>1
    Pax_t=continuidad(3:numel(continuidad(:,1)),1)';
    Pay_t=continuidad(3:numel(continuidad(:,2)),2)';
    z_t=continuidad(3:numel(continuidad(:,3)),3)';
end
arreglos=menu('Desea calcular otro arreglo para el mismo tendido?',...
              'SI','NO');
if arreglos==2
    break
else
% Creacin archivos de continuidad 
        c_p1=max(unos);
    if roll_along==1
        c_p1_a1=dimension;        
        c_p2=roll_along;
        c_p3=numel(A2);
        c_p4_a1=arreglo;
        bloque2=[A2',B2',M2',N2'];
    else
        c_p1_a1=0;        
        c_p2=0;
        c_p3=0;
        c_p4_a1=0;
    end
    bloque1=[c_p1_a1,c_p2,c_p3,c_p4_a1];
    bloque1_a1=[pe,ei,ef,n];    
    bloque1_a3=[c_p1,numel(coordenadas(:,1)),0,0];
    bloque3=[Pax',Pay',z',zeros(numel(Pax),1)];
    if cont_arr==1
        dlmwrite('continuidad.txt',bloque1,'\t');
        dlmwrite('continuidad.txt',bloque1_a1,'-append','delimiter','\t');
    end
    dlmwrite('continuidad.txt',bloque3,'-append','delimiter','\t');
    if roll_along==1
        dlmwrite('continuidad1.txt',bloque1,'\t');    
        dlmwrite('continuidad1.txt',bloque2,'-append','delimiter','\t');
    end    
    dlmwrite('continuidad2.txt',bloque1_a3,'\t');
    dlmwrite('continuidad2.txt',coordenadas,'-append','delimiter','\t');
    dlmwrite('continuidad3.txt',{sal_AGI},'');
    dlmwrite('continuidad4.txt',{sal_inf},'');    
    close all;clear;clc
    load 'continuidad.txt';    
    load 'continuidad2.txt';
    fid=fopen('continuidad3.txt','r');
     s1=textscan(fid,'%s');
     salida1=char(s1{1});
    fclose(fid);
    fid=fopen('continuidad4.txt','r');
     s2=textscan(fid,'%s');
     salida2=char(s2{1});
    fclose(fid);
    numCP=continuidad2(1,1);
    c_c=continuidad2(1,2);
    coordenadas=continuidad2(2:c_c+1,:);
    c_eroll=continuidad(1,2);    
    if c_eroll==1
        load 'continuidad1.txt';
        dimension=continuidad(1,1);
        c_limite=continuidad(1,3);
        arreglo=continuidad(1,4);
        c_A1=continuidad1(2:c_limite+1,1)';
        c_B1=continuidad1(2:c_limite+1,2)';
        c_M1=continuidad1(2:c_limite+1,3)';
        c_N1=continuidad1(2:c_limite+1,4)';
        c_roll_along=c_eroll;
        pe=continuidad(2,1);
        ei=continuidad(2,2);
        ef=continuidad(2,3);
        n=continuidad(2,4);
    else
        c_roll_along=0;
    end    
end
%!!!!!!!!! FIN DE LA CREACIN DE ARCHIVOS ASCII

end %+++++++++++++++FIN Iteracin de repeticin

%!!!!!!!!!! CREACIN DE GRFICA !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
if roll_along==1
    
figure()
hold on
plot3(cx,cy,cz,'o-k','LineWidth',1.4,'MarkerFaceColor','k')
if cont_arr>1
    if cx(2)~=cx(1)
        dc=cx(2)-cx(1);
        Pax1=Pax-dc*((cont_arr-1)*eroll);
        Pay1=Pay;
    elseif cy(2)~=cy(1)        
        dc=cy(2)-cy(1);
        Pay1=Pay-dc*((cont_arr-1)*eroll);
        Pax1=Pax;
    end
    plot3(Pax1,Pay1,z,'dk','MarkerFaceColor','g')
    vvvv={num2str(numel(Pax));'cuadripolos'};
else
    plot3(Pax,Pay,z,'dk','MarkerFaceColor','g')
end
if min(cx)==0 && max(cx)==0
axis([min(cx)-1 max(cx)+1 min(cy)-max(cy)*.1 max(cy)+max(cy)*.1])
elseif min(cy)==0 && max(cy)==0
axis([min(cx)-max(cx)*.1 max(cx)+max(cx)*.1 min(cy)-1 max(cy)+1])    
else
axis([min(cx)-max(cx)*.1,max(cx)+max(cx)*.1,min(cy)-max(cy)*.1,...
     max(cy)+max(cy)*.1])    
end
title('\bf Tendido')
xlabel('x')
ylabel('y')
zlabel('z')
if min(cx)==0 && max(cx)==0
text((max(cx)+.5),(max(cy)+max(cy)*.1)*0.85,min(z)*0.85,vvvv)
elseif min(cy)==0 && max(cy)==0
text((max(cx)+max(cx)*.1)*0.85,(max(cy)+.5),min(z)*0.85,vvvv)
else
text((max(cx)+max(cx)*.1)*0.85,(max(cy)+max(cy)*.1)*0.85,min(z)*0.85,vvvv)
end
camproj('orthographic')
box on
grid on

figure()
vvvv={num2str(max(unos4));'cuadripolos'};
hold on
plot3(cx,cy,cz,'o-k','LineWidth',1.4,'MarkerFaceColor','k')
if cont_arr>1
    if cx(2)~=cx(1)
        dc=cx(2)-cx(1);
        Paxr=Paxr-dc*((cont_arr-1)*eroll);
    elseif cy(2)~=cy(1)        
        dc=cy(2)-cy(1);
        Payr=Payr-dc*((cont_arr-1)*eroll);
    end
    plot3(Paxr,Payr,zr,'dk','MarkerFaceColor','g')
    vvvv={num2str(numel(A2));'cuadripolos'};
else
    plot3(Paxr,Payr,zr,'dk','MarkerFaceColor','g')
end
if min(cx)==0 && max(cx)==0
axis([min(cx)-1 max(cx)+1 min(cy)-max(cy)*.1 max(cy)+max(cy)*.1])
elseif min(cy)==0 && max(cy)==0
axis([min(cx)-max(cx)*.1 max(cx)+max(cx)*.1 min(cy)-1 max(cy)+1])    
else
axis([min(cx)-max(cx)*.1,max(cx)+max(cx)*.1,min(cy)-max(cy)*.1,...
     max(cy)+max(cy)*.1])    
end
title('\bf Tendido')
xlabel('x')
ylabel('y')
zlabel('z')
if min(cx)==0 && max(cx)==0
text((max(cx)+.5),(max(cy)+max(cy)*.1)*0.85,min(z)*0.85,vvvv)
elseif min(cy)==0 && max(cy)==0
text((max(cx)+max(cx)*.1)*0.85,(max(cy)+.5),min(z)*0.85,vvvv)
else
text((max(cx)+max(cx)*.1)*0.85,(max(cy)+max(cy)*.1)*0.85,min(z)*0.85,vvvv)
end
camproj('orthographic')
box on
grid on

end

figure()
hold on
plot3(cx,cy,cz,'o-k','LineWidth',1.4,'MarkerFaceColor','k')
if cont_arr>1
    plot3(Pax,Pay,z,'dk','MarkerFaceColor','g')
    plot3(Pax_t,Pay_t,z_t,'dk','MarkerFaceColor','g')
else
    plot3(Pax,Pay,z,'dk','MarkerFaceColor','g')
end
if roll_along==1
    plot3(Paxr,Payr,zr,'dk','MarkerFaceColor','g')
    vvvv={num2str(max(unosr));'cuadripolos'};
end
if min(cx)==0 && max(cx)==0
axis([min(cx)-1 max(cx)+1 min(cy)-max(cy)*.1 max(cy)+max(cy)*.1])
elseif min(cy)==0 && max(cy)==0
axis([min(cx)-max(cx)*.1 max(cx)+max(cx)*.1 min(cy)-1 max(cy)+1])    
else
axis([min(cx)-max(cx)*.1,max(cx)+max(cx)*.1,min(cy)-max(cy)*.1,...
     max(cy)+max(cy)*.1])
end
title('\bf Tendido')
xlabel('x')
ylabel('y')
zlabel('z')
if min(cx)==0 && max(cx)==0
text((max(cx)+.5),(max(cy)+max(cy)*.1)*0.85,min(z)*0.85,vvvv)
elseif min(cy)==0 && max(cy)==0
text((max(cx)+max(cx)*.1)*0.85,(max(cy)+.5),min(z)*0.85,vvvv)
else
text((max(cx)+max(cx)*.1)*0.85,(max(cy)+max(cy)*.1)*0.85,min(z)*0.85,vvvv)
end
camproj('orthographic')
box on
grid on
%!!!!!!!!!! FIN CREACIN DE GRFICA

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PROGRAMA DE SECUENCIAS CUADRIPOLARES (SecuenciasCP.m) %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%