%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% FUNCIN QUE CALCULA LAS COORDENADAS DEL PUNTO MEDIO ENTRE A Y B %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [Xc,Yc]=XcYc(cxA,cyA,cxB,cyB)
cxA=cxA+0.001;
cyA=cyA+0.001;
cxB=cxB+0.001;
cyB=cyB+0.001;
MAB=((cxA-cxB)^2+(cyA-cyB)^2)^0.5;
MA=(cxA^2+cyA^2)^0.5;
MB=(cxB^2+cyB^2)^0.5;
an3=acos(cxA/MA);
an2=acos(cxB/MB);
an1=abs(an3-an2);
MAC=MAB/2;
% Parmetros de la recta OA
m_OA=cyA/cxA;
% Parmetros de la recta perpendicular a OA
b_OAp=cyA+cxA/m_OA;
% Parmetros de la recta OB
m_OB=cyB/cxB;
% Coordenadas de la interseccin de la recta perpendicular a OA y
%           de la recta OB (punto I)
cxI=b_OAp/(1/m_OA+m_OB);
cyI=m_OB*cxI;
% Magnitud del punto I
MI=(cxI^2+cyI^2)^0.5;
if MB>MI
    an6=pi-asin(MB*sin(an1)/MAB);
elseif MI==MB
    an6=pi/2;
else
    an6=asin(MB*sin(an1)/MAB);
end
CMC=(MA^2+MAC^2-2*MA*MAC*cos(an6))^0.5;
an4=asin(MAC*sin(an6)/CMC);
if an3>an2
    an5=abs(an3-an4);
elseif an3==an2
    an5=an3;
else
    an5=an3+an4;
end
Xc=CMC*cos(an5)-0.001;
Yc=CMC*sin(an5)-0.001;
if Xc<0.0000001
    Xc=0;
end
if Yc<0.0000001
    Yc=0;
end